import { DomSanitizer } from '@angular/platform-browser';
import { IOption, ISelectItem } from './models';
export declare const imgBase64ToBlob: (Base64Image: string, imageType?: string) => Blob;
export declare const svgToBase64src: (rawSvg: string) => string;
export declare const prepRes: (item: string, sanitizer: DomSanitizer) => import("@angular/platform-browser").SafeResourceUrl;
export declare const sanitizeHTML: (item: string, sanitizer: DomSanitizer) => string | null;
export declare const getSvgSafeRes: (file: string, sanitizer: DomSanitizer) => import("@angular/platform-browser").SafeResourceUrl;
export declare const getPngSafeRes: (file: string, sanitizer: DomSanitizer) => import("@angular/platform-browser").SafeResourceUrl;
export declare const blobToSafeRes: (blob: Blob, sanitizer: DomSanitizer) => import("@angular/platform-browser").SafeResourceUrl;
/**
 *
 * @param data - option value (could be simple string or complex object to resolve)
 * @param field - the key (or complex lookup object key) of data object to resolve value by
 * @returns resolved single option value (Input for SelectItem)
 */
export declare const resolveFieldData: (data: IOption, field?: string | undefined) => string | null;
export declare const isValue: <T>(obj: T) => obj is T;
export declare const isEmpty: <T>(obj: T) => obj is T;
export declare const isString: (obj: IOption) => obj is string;
export declare const isObject: <T extends string | object>(obj: T) => obj is T;
export declare const isSelectItem: (obj: ISelectItem | string) => obj is ISelectItem<string | Record<string, string | object>>;
export declare const areEqual: (obj1: IOption | null, obj2: IOption | null, field?: string | undefined) => boolean;
export declare enum OptionKeyboardEventHandleKeys {
    ArrowDown = "ArrowDown",
    Down = "Down",
    ArrowUp = "ArrowUp",
    Enter = "Enter",
    Escape = "Escape",
    Esc = "Esc",
    Up = "Up",
    Tab = "Tab",
    Space = " "
}
//# sourceMappingURL=helpers.d.ts.map