import { TemplateRef } from '@angular/core';
export interface ITemplates {
    containerTemplate?: TemplateRef<HTMLElement>;
    selectedItemTemplate?: TemplateRef<HTMLElement>;
    openerBtnTemplate?: TemplateRef<HTMLElement>;
    itemslistTemplate?: TemplateRef<HTMLElement>;
}
export declare type ISelectItem<T = Record<string, string | object> | string> = {
    label?: string;
    value?: T;
    styleClass?: string;
    icon?: string;
    title?: string;
    disabled?: boolean;
};
export declare type IOption = ISelectItem | ISelectItem | Record<string, string | object> | string | undefined;
export interface IOptionClickEvent {
    baseEvent: MouseEvent;
    option: IOption;
}
declare type StylesSet = {
    [K in keyof CSSStyleDeclaration]: CSSStyleDeclaration[K];
};
/**
 * @type {StylesSet} BasicStylesSet - common styles' set to be applied to header / overlay of the Select component
 */
export declare type BasicStylesSet = Partial<StylesSet>;
export {};
//# sourceMappingURL=models.d.ts.map